package com.swysoft.swybanking.fms;

//TODO: Error Logger
//http://www.onjava.com/pub/a/onjava/2002/06/19/log.html
//http://www.vogella.com/tutorials/Logging/article.html

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.io.IOException;
import java.nio.file.NoSuchFileException;
import java.nio.file.Paths;
import java.text.NumberFormat;
import java.util.List;

import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import org.jdesktop.beansbinding.AutoBinding;
import org.jdesktop.beansbinding.AutoBinding.UpdateStrategy;
import org.jdesktop.beansbinding.BeanProperty;
import org.jdesktop.beansbinding.Bindings;
import org.jdesktop.swingbinding.JComboBoxBinding;
import org.jdesktop.swingbinding.SwingBindings;

import com.swysoft.swybanking.mdl.AccTblBankMdl;
import com.swysoft.swybanking.mdl.AccTblSplitsMdl;
import com.swysoft.swybanking.mdl.AccountMdl;
import com.swysoft.swybanking.mdl.CatLookUpMdl;
import com.swysoft.swybanking.mdl.ComboLookUpMdl;
import com.swysoft.swybanking.mdl.QifMdl;
import com.swysoft.swybanking.mdl.StaticItems.MoveTo;
import com.swysoft.swybanking.set.ComboLookUpMdlException;
import com.swysoft.swybanking.set.CurrencyEditor;
import com.swysoft.swybanking.set.CurrencyRenderer;
import com.swysoft.swybanking.set.QifFmt;
import com.swysoft.swybanking.set.QifSplitFmt;

public class AccountViewJ {

	public JFrame frame;

	private JCheckBox cbxCurrent;
	private JCheckBox cbxShowOnlyCurrent;
	private JComboBox<String> cboCategory;
	private JComboBox<String> cboCode;
	private JComboBox<String> cboPayee;
	private JComboBox<String> cboSplitCat = new JComboBox<String>();
	private JLabel lblIdVal;
	private JPanel pnlQifConvrtd;
	private JPanel pnlQifBank;
	private JTable tblQifBank;
	private JTable tblSplits;
	private JTextField txtDate;
	private JTextField txtAmount;
	private JTextField txtChequeNum;
	private JTextField txtMemo;
	private JTextField txtDifference;
	private JTextField txtCode;
	private JTextField txtDescription;
	private JTextField txtBankfile;
	private JTextField txtCnvtToFile;
	private JTextField txtFNavRowNum;
	private JTextField txtFNavTotal;
	private JTextField txtQNavRowNum;
	private JTextField txtQNavTotal;

	private static String dbPath = "C:/Users/Ray/workspace/SwyBankingJ/src/com/swysoft/swybanking/res/bktrans.s3db";
	private static AccountMdl accountMdl = null; // Initialised in the main() function

	private AccTblBankMdl accTblBankMdl = null;
	private AccTblSplitsMdl accTblSplitsMdl = null;
	private CatLookUpMdl catLookUpMdl = null;
	private ComboLookUpMdl cboCategoryLkUpMdl = null;
	private ComboLookUpMdl cboPayeeLkUpMdl = null;
	private QifMdl convtdQifMdl = null;
	private QifMdl bankQifMdl = null;

	private NumberFormat nf = NumberFormat.getCurrencyInstance();
	private JButton btnConvert;
	private JCheckBox chckbxReconciled;
	private JTextField txtConvrtFileWarning;
	private JTextField txtErrMsg;
	private JTextField txtFailedConvsn;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {

				try {
					AccountViewJ window = new AccountViewJ();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public AccountViewJ() {

		// First fire up copies of the models

		try {
			accountMdl = new AccountMdl(Paths.get(dbPath));
		} catch (Exception e) {
			JOptionPane.showConfirmDialog(frame,
					"System error\n" + e.getMessage());
		}

		try {
			cboCategoryLkUpMdl = new ComboLookUpMdl(Paths.get(dbPath));
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		try {
			cboPayeeLkUpMdl = new ComboLookUpMdl(Paths.get(dbPath));
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		convtdQifMdl = new QifMdl();

		bankQifMdl = new QifMdl();

		accTblBankMdl = new AccTblBankMdl();

		accTblSplitsMdl = new AccTblSplitsMdl();

		try {
			catLookUpMdl = new CatLookUpMdl(Paths.get(dbPath));
		} catch (NoSuchFileException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}

		initialize();
	}

	/**
	 * Initialise the contents of the frame.
	 */
	private void initialize() {

		frame = new JFrame();
		frame.setBackground(new Color(100, 149, 237));
		frame.setBounds(100, 100, 603, 605);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		/*
		 * *************** JMenuBar items *******************
		 */

		JMenuBar menuBar = new JMenuBar();
		frame.setJMenuBar(menuBar);
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent windowEvent) {
				// cause any 'dirty' records to be updated and filed
				convtdQifMdl.saveCurrentFile();
				//				if (JOptionPane.showConfirmDialog(frame,
				//						"Are you sure to close this window?",
				//						"Really Closing?", JOptionPane.YES_NO_OPTION,
				//						JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
				//					System.exit(0);
				//				}
				System.exit(0);
			}
		});

		JMenu mnNewMenu = new JMenu("Manage");
		mnNewMenu.setFont(new Font("Segoe UI", Font.BOLD, 12));
		menuBar.add(mnNewMenu);

		JMenuItem mntmNewMenuItem = new JMenuItem("Input Conversion");
		mntmNewMenuItem.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		//		mntmNewMenuItem.addActionListener(new ActionListener() {
		//		mnNewMenu.add(mntmNewMenuItem);

		JMenuItem mntmSplits = new JMenuItem("Splits");
		mntmSplits.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		mntmSplits.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		mnNewMenu.add(mntmSplits);

		JMenuItem mntmAccounts = new JMenuItem("Accounts");
		mntmAccounts.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		mnNewMenu.add(mntmAccounts);

		JMenuItem mntmPayee = new JMenuItem("Payee");
		mntmPayee.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		mnNewMenu.add(mntmPayee);

		JMenuItem mntmCategories = new JMenuItem("Categories");
		mntmCategories.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		mnNewMenu.add(mntmCategories);

		JMenu mnReports = new JMenu("Reports");
		mnReports.setFont(new Font("Segoe UI", Font.BOLD, 12));
		menuBar.add(mnReports);

		JMenuItem mntmOrphanPayees = new JMenuItem("Orphan Payees");
		mntmOrphanPayees
				.setFont(new Font("Segoe UI Semilight", Font.PLAIN, 12));
		mnReports.add(mntmOrphanPayees);
		frame.getContentPane().setLayout(null);

		/*
		 * *************** JTabbed Panel *******************
		 */

		JTabbedPane tabbedPanel = new JTabbedPane(JTabbedPane.TOP);
		tabbedPanel.addMouseWheelListener(new MouseWheelListener() {
			public void mouseWheelMoved(MouseWheelEvent mseEvent) {

				if (tblSplits.isEditing())
					tblSplits.getCellEditor().stopCellEditing();

				if (mseEvent.getWheelRotation() > 0) {
					try {
						convtdQifMdl.moveToRow(MoveTo.NEXT_REC);
					} catch (Exception e) {
						e.printStackTrace();
					}
				} else {
					try {
						convtdQifMdl.moveToRow(MoveTo.PREVIOUS_REC);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		});
		tabbedPanel.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tabbedPanel.setBounds(10, 207, 569, 325);
		frame.getContentPane().add(tabbedPanel);

		pnlQifConvrtd = new JPanel();
		tabbedPanel.addTab("Converted File", null, pnlQifConvrtd, null);
		pnlQifConvrtd.setLayout(null);

		JScrollPane scrPaneQif = new JScrollPane();
		scrPaneQif.setBounds(16, 162, 504, 91);
		pnlQifConvrtd.add(scrPaneQif);

		cboCategory = new JComboBox<String>();
		cboCategory.setFont(new Font("Tahoma", Font.PLAIN, 11));
		cboCategory.setEditable(true);
		cboCategory.setBounds(180, 28, 282, 20);
		pnlQifConvrtd.add(cboCategory);

		cboPayee = new JComboBox<String>();
		cboPayee.addPopupMenuListener(new PopupMenuListener() {
			public void popupMenuCanceled(PopupMenuEvent arg0) {
			}

			public void popupMenuWillBecomeInvisible(PopupMenuEvent arg0) {
			}

			public void popupMenuWillBecomeVisible(PopupMenuEvent arg0) {
				try {
					String sql = "SELECT name FROM Payee ORDER BY name;";
					cboPayeeLkUpMdl.setSqlStatement(sql);
					cboPayeeLkUpMdl.refreshResultSet();
				} catch (ComboLookUpMdlException e) {
					e.printStackTrace();
				}
			}
		});

		cboPayee.setEditable(true);
		cboPayee.setFont(new Font("Tahoma", Font.PLAIN, 11));
		cboPayee.setBounds(16, 69, 446, 20);
		pnlQifConvrtd.add(cboPayee);

		txtDate = new JTextField();
		txtDate.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtDate.setText("Date");
		txtDate.setBounds(16, 28, 60, 20);
		pnlQifConvrtd.add(txtDate);
		txtDate.setColumns(10);

		txtAmount = new JTextField();
		txtAmount.setHorizontalAlignment(SwingConstants.RIGHT);
		txtAmount.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtAmount.setText("Amount");
		txtAmount.setBounds(86, 28, 84, 20);
		pnlQifConvrtd.add(txtAmount);
		txtAmount.setColumns(10);

		txtChequeNum = new JTextField();
		txtChequeNum.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtChequeNum.setText("ChequeNum");
		txtChequeNum.setBounds(468, 28, 86, 20);
		pnlQifConvrtd.add(txtChequeNum);
		txtChequeNum.setColumns(10);

		txtMemo = new JTextField();
		txtMemo.setText("Memo");
		txtMemo.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtMemo.setBounds(16, 113, 538, 20);
		pnlQifConvrtd.add(txtMemo);
		txtMemo.setColumns(10);

		txtDifference = new JTextField();
		txtDifference.setHorizontalAlignment(SwingConstants.RIGHT);
		txtDifference.setBackground(new Color(255, 127, 80));
		txtDifference.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtDifference.setEditable(false);
		txtDifference.setText("Difference");
		txtDifference.setBounds(55, 144, 86, 20);
		txtDifference.setColumns(10);
		txtDifference.setVisible(false);
		pnlQifConvrtd.add(txtDifference);

		JLabel lblDate = new JLabel("Date");
		lblDate.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblDate.setBounds(16, 11, 60, 14);
		pnlQifConvrtd.add(lblDate);

		JLabel lblAmount = new JLabel("Amount");
		lblAmount.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblAmount.setBounds(86, 11, 60, 14);
		pnlQifConvrtd.add(lblAmount);

		JLabel lblCategory = new JLabel("Category");
		lblCategory.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblCategory.setBounds(180, 11, 60, 14);
		pnlQifConvrtd.add(lblCategory);

		JLabel lblChequeNum = new JLabel("Cheque Num");
		lblChequeNum.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblChequeNum.setBounds(469, 11, 78, 14);
		pnlQifConvrtd.add(lblChequeNum);

		JLabel lblPayee = new JLabel("Payee");
		lblPayee.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblPayee.setBounds(16, 55, 60, 14);
		pnlQifConvrtd.add(lblPayee);

		JLabel lblMemo = new JLabel("Memo");
		lblMemo.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblMemo.setBounds(16, 100, 60, 14);
		pnlQifConvrtd.add(lblMemo);

		JLabel lblSplits = new JLabel("Splits");
		lblSplits.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblSplits.setBounds(20, 147, 60, 14);
		pnlQifConvrtd.add(lblSplits);

		tblSplits = new JTable(accTblSplitsMdl);
		tblSplits.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tblSplits.getTableHeader().setFont(new Font("Tahoma", Font.PLAIN, 11));
		tblSplits.addFocusListener(new FocusAdapter() {
			@Override
			public void focusGained(FocusEvent arg0) {
				cboSplitCat.removeAllItems();
				for (String code : catLookUpMdl.getCodeList()) {
					cboSplitCat.addItem(code);
				}
				cboSplitCat.setEditable(true);
			}
		});
		tblSplits.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		tblSplits.setFillsViewportHeight(true);
		tblSplits.getColumnModel().getColumn(0).setPreferredWidth(10);
		tblSplits.getColumnModel().getColumn(1).setPreferredWidth(100);
		tblSplits.getColumnModel().getColumn(2).setPreferredWidth(100);
		tblSplits.getColumnModel().getColumn(1)
				.setCellEditor(new DefaultCellEditor(cboSplitCat));
		tblSplits.setDefaultRenderer(Double.class, new CurrencyRenderer(nf));
		tblSplits.setDefaultEditor(Double.class, new CurrencyEditor(nf));
		tblSplits.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
		scrPaneQif.setViewportView(tblSplits);

		JToolBar tlbrQifNav = new JToolBar();
		tlbrQifNav.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrQifNav.setFloatable(false);
		tlbrQifNav.setBounds(16, 264, 270, 23);
		pnlQifConvrtd.add(tlbrQifNav);

		JButton btnQNavFirst = new JButton("");
		btnQNavFirst.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					convtdQifMdl.moveToRow(MoveTo.FIRST_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnQNavFirst.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnQNavFirst
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-first-view-icon 2.png")));
		tlbrQifNav.add(btnQNavFirst);

		JButton btnQNavPrevious = new JButton("");
		btnQNavPrevious.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					convtdQifMdl.moveToRow(MoveTo.PREVIOUS_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnQNavPrevious.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnQNavPrevious
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-previous-view-icon 2.png")));
		tlbrQifNav.add(btnQNavPrevious);

		txtQNavRowNum = new JTextField();
		txtQNavRowNum.setHorizontalAlignment(SwingConstants.RIGHT);
		txtQNavRowNum.setText("99999");
		txtQNavRowNum.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrQifNav.add(txtQNavRowNum);
		txtQNavRowNum.setColumns(10);

		JButton btnQNavNext = new JButton("");
		btnQNavNext.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					convtdQifMdl.moveToRow(MoveTo.NEXT_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnQNavNext
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-next-view-icon 2.png")));
		tlbrQifNav.add(btnQNavNext);

		JButton btnQNavLast = new JButton("");
		btnQNavLast.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				//System.out.println("btnQNavLast-actionPerformed= " + arg0);
				try {
					convtdQifMdl.moveToRow(MoveTo.LAST_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnQNavLast
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-last-view-icon 2.png")));
		tlbrQifNav.add(btnQNavLast);

		JLabel lblQNavOf = new JLabel(" of ");
		lblQNavOf.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrQifNav.add(lblQNavOf);

		txtQNavTotal = new JTextField();
		txtQNavTotal.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtQNavTotal.setEditable(false);
		txtQNavTotal.setText("99999");
		tlbrQifNav.add(txtQNavTotal);
		txtQNavTotal.setColumns(10);

		JButton btnQNavAdd = new JButton("");
		btnQNavAdd
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-add-icon 2.png")));
		tlbrQifNav.add(btnQNavAdd);

		JButton btnQNavDel = new JButton("");
		btnQNavDel
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-remove-icon 2.png")));
		tlbrQifNav.add(btnQNavDel);

		JButton btnQNavEscape = new JButton("Escape");
		btnQNavEscape.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrQifNav.add(btnQNavEscape);

		chckbxReconciled = new JCheckBox("Reconciled");
		chckbxReconciled.setFont(new Font("Tahoma", Font.PLAIN, 11));
		chckbxReconciled.setBounds(468, 68, 78, 23);
		pnlQifConvrtd.add(chckbxReconciled);

		txtFailedConvsn = new JTextField();
		txtFailedConvsn.setHorizontalAlignment(SwingConstants.CENTER);
		txtFailedConvsn
				.setText("This transaction did not have a matching conversion entry");
		txtFailedConvsn.setBackground(Color.YELLOW);
		txtFailedConvsn.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtFailedConvsn.setBounds(118, 91, 298, 20);
		pnlQifConvrtd.add(txtFailedConvsn);
		txtFailedConvsn.setColumns(10);

		JButton btnDelQifRow = new JButton("");
		btnDelQifRow.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnDelQifRow
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-remove-icon 2.png")));
		btnDelQifRow.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				accTblSplitsMdl.deleteRow(tblSplits.getSelectedRow());
			}
		});
		btnDelQifRow.setBounds(530, 211, 18, 18);
		pnlQifConvrtd.add(btnDelQifRow);

		JButton btnAddQifRow = new JButton("");
		btnAddQifRow
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-add-icon 2.png")));
		btnAddQifRow.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				accTblSplitsMdl.addRow();
			}
		});
		btnAddQifRow.setBounds(530, 192, 18, 18);
		pnlQifConvrtd.add(btnAddQifRow);

		pnlQifBank = new JPanel();
		tabbedPanel.addTab("Bank File", null, pnlQifBank, null);
		pnlQifBank.setLayout(null);

		JScrollPane scrPnlQifBank = new JScrollPane();
		scrPnlQifBank.setFont(new Font("Tahoma", Font.PLAIN, 11));
		scrPnlQifBank.setBounds(10, 11, 544, 275);
		pnlQifBank.add(scrPnlQifBank);

		tblQifBank = new JTable(accTblBankMdl);
		tblQifBank.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tblQifBank.getTableHeader().setFont(new Font("Tahoma", Font.PLAIN, 11));
		tblQifBank.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
		tblQifBank.setFillsViewportHeight(true);
		tblQifBank.getColumnModel().getColumn(0).setPreferredWidth(15);
		tblQifBank.getColumnModel().getColumn(1).setPreferredWidth(15);
		tblQifBank.getColumnModel().getColumn(2).setPreferredWidth(250);
		tblQifBank.getColumnModel().getColumn(3).setPreferredWidth(15);
		tblQifBank.setDefaultRenderer(Double.class, new CurrencyRenderer(nf));
		//tblQifBank.setDefaultEditor(Double.class, new CurrencyEditor(nf));

		scrPnlQifBank.setViewportView(tblQifBank);

		JPanel pnlFailedConvert = new JPanel();
		tabbedPanel.addTab("Failed Convert", null, pnlFailedConvert, null);
		tabbedPanel.setEnabledAt(2, true);
		tabbedPanel.setBackgroundAt(2, Color.LIGHT_GRAY);
		tabbedPanel.setForegroundAt(2, Color.BLACK);

		/*
		 * *************** JComboBox Items *******************
		 */

		cboCode = new JComboBox<String>();
		cboCode.getEditor().getEditorComponent()
				.addFocusListener(new FocusListener() {
					public void focusGained(FocusEvent arg0) {
					}

					public void focusLost(FocusEvent arg0) {
						// clear out the displayed field
						cboCode.setSelectedItem("");
					}
				});

		cboCode.setFont(new Font("Tahoma", Font.PLAIN, 11));
		cboCode.setEditable(true);
		cboCode.setBounds(351, 57, 200, 20);
		frame.getContentPane().add(cboCode);

		/*
		 * *************** JCheckBox Items *******************
		 */

		cbxShowOnlyCurrent = new JCheckBox("Show Only Current");
		cbxShowOnlyCurrent.setFont(new Font("Tahoma", Font.PLAIN, 11));
		cbxShowOnlyCurrent.setBounds(120, 26, 117, 23);
		frame.getContentPane().add(cbxShowOnlyCurrent);

		cbxCurrent = new JCheckBox("Current");
		cbxCurrent.setFont(new Font("Tahoma", Font.PLAIN, 11));
		cbxCurrent.setBounds(277, 56, 68, 23);
		frame.getContentPane().add(cbxCurrent);

		/*
		 * *************** JTextField Items *******************
		 */

		txtCode = new JTextField();
		txtCode.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtCode.setText("Code");
		txtCode.setBounds(81, 57, 190, 20);
		frame.getContentPane().add(txtCode);
		txtCode.setColumns(10);

		txtDescription = new JTextField();
		txtDescription.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtDescription.setText("Description");
		txtDescription.setBounds(81, 88, 337, 20);
		frame.getContentPane().add(txtDescription);
		txtDescription.setColumns(10);

		txtBankfile = new JTextField();
		txtBankfile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtBankfile.setText("BankFile");
		txtBankfile.setBounds(81, 115, 457, 20);
		frame.getContentPane().add(txtBankfile);
		txtBankfile.setColumns(10);

		txtCnvtToFile = new JTextField();
		txtCnvtToFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtCnvtToFile.setText("CnvtToFile");
		txtCnvtToFile.setColumns(10);
		txtCnvtToFile.setBounds(81, 146, 457, 20);
		frame.getContentPane().add(txtCnvtToFile);

		/*
		 * *************** JButton Items *******************
		 */

		JButton btnImpfile = new JButton("");
		btnImpfile.setIcon(new ImageIcon(AccountViewJ.class
				.getResource("/com/swysoft/swybanking/pics/Folder-icon.png")));
		btnImpfile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnImpfile.setBounds(545, 115, 32, 23);
		frame.getContentPane().add(btnImpfile);

		JButton btnUplFile = new JButton("");
		btnUplFile.setIcon(new ImageIcon(AccountViewJ.class
				.getResource("/com/swysoft/swybanking/pics/Folder-icon.png")));
		btnUplFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnUplFile.setBounds(547, 146, 32, 23);
		frame.getContentPane().add(btnUplFile);

		btnConvert = new JButton("Convert");
		btnConvert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
			}
		});
		btnConvert.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				accountMdl.convertQifFile(convtdQifMdl);
			}
		});
		btnConvert.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnConvert.setBounds(494, 177, 80, 23);
		frame.getContentPane().add(btnConvert);

		/*
		 * *************** JToolBar Record Navigation *******************
		 */

		initJToolBarFileNav();

		/*
		 * *************** JLabel Items *******************
		 */

		JLabel lblAccountsFrm = new JLabel("Accounts");
		lblAccountsFrm.setFont(new Font("Tahoma", Font.BOLD, 16));
		lblAccountsFrm.setBounds(10, 30, 81, 19);
		frame.getContentPane().add(lblAccountsFrm);

		JLabel lblCode = new JLabel("Acc Code");
		lblCode.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblCode.setBounds(20, 58, 60, 14);
		frame.getContentPane().add(lblCode);

		JLabel lblDesc = new JLabel("Description");
		lblDesc.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblDesc.setBounds(20, 91, 60, 14);
		frame.getContentPane().add(lblDesc);

		JLabel lblBankFile = new JLabel("Bank File");
		lblBankFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblBankFile.setBounds(20, 118, 60, 14);
		frame.getContentPane().add(lblBankFile);

		JLabel lblCnvtToFile = new JLabel("Convert to");
		lblCnvtToFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblCnvtToFile.setBounds(20, 147, 60, 14);
		frame.getContentPane().add(lblCnvtToFile);

		JLabel lblSearchFor = new JLabel("Search For Code");
		lblSearchFor.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblSearchFor.setBounds(373, 42, 87, 14);
		frame.getContentPane().add(lblSearchFor);

		lblIdVal = new JLabel("999999");
		lblIdVal.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblIdVal.setBounds(536, 1, 41, 14);
		frame.getContentPane().add(lblIdVal);

		JLabel lblId = new JLabel("ID : ");
		lblId.setBounds(516, 1, 22, 14);
		frame.getContentPane().add(lblId);

		cboCode.setSelectedItem("");

		txtConvrtFileWarning = new JTextField();
		txtConvrtFileWarning.setEditable(false);
		txtConvrtFileWarning.setHorizontalAlignment(SwingConstants.CENTER);
		txtConvrtFileWarning.setText("Conversion is 30 days old");
		txtConvrtFileWarning.setBackground(new Color(255, 255, 0));
		txtConvrtFileWarning.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtConvrtFileWarning.setBounds(351, 167, 140, 20);
		txtConvrtFileWarning.setColumns(10);
		frame.getContentPane().add(txtConvrtFileWarning);

		txtErrMsg = new JTextField();
		txtErrMsg.setVisible(false);
		txtErrMsg.setBackground(Color.YELLOW);
		txtErrMsg.setText("This is where the error messages can go");
		txtErrMsg.setBounds(10, 1, 496, 20);
		frame.getContentPane().add(txtErrMsg);
		txtErrMsg.setColumns(10);

		initDataBindings();
	}

	private void initJToolBarFileNav() {

		/*
		 * *************** JToolBar File Navigation Items *******************
		 */

		JToolBar tlbrFileNav = new JToolBar();
		tlbrFileNav.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrFileNav.setFloatable(false);
		tlbrFileNav.setBounds(81, 177, 270, 23);
		frame.getContentPane().add(tlbrFileNav);

		JButton btnFNavFirst = new JButton("");
		btnFNavFirst.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					accountMdl.moveToRec(MoveTo.FIRST_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnFNavFirst.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnFNavFirst
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-first-view-icon 2.png")));
		tlbrFileNav.add(btnFNavFirst);

		JButton btnFNavPrevious = new JButton("");
		btnFNavPrevious.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					accountMdl.moveToRec(MoveTo.PREVIOUS_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnFNavPrevious.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnFNavPrevious
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-previous-view-icon 2.png")));
		tlbrFileNav.add(btnFNavPrevious);

		txtFNavRowNum = new JTextField();
		txtFNavRowNum.setHorizontalAlignment(SwingConstants.RIGHT);
		txtFNavRowNum.setText("99999");
		txtFNavRowNum.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrFileNav.add(txtFNavRowNum);
		txtFNavRowNum.setColumns(10);

		JButton btnFNavNext = new JButton("");
		btnFNavNext.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				try {
					accountMdl.moveToRec(MoveTo.NEXT_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnFNavNext
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-next-view-icon 2.png")));
		tlbrFileNav.add(btnFNavNext);

		JButton btnFNavLast = new JButton("");
		btnFNavLast.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				try {
					accountMdl.moveToRec(MoveTo.LAST_REC);
				} catch (Exception e1) {
					JOptionPane.showConfirmDialog(frame,
							"System error\n" + e1.getMessage());
				}
			}
		});
		btnFNavLast
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-go-last-view-icon 2.png")));
		tlbrFileNav.add(btnFNavLast);

		JLabel lblFNavOf = new JLabel(" of ");
		lblFNavOf.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrFileNav.add(lblFNavOf);

		txtFNavTotal = new JTextField();
		txtFNavTotal.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtFNavTotal.setEditable(false);
		txtFNavTotal.setText("99999");
		tlbrFileNav.add(txtFNavTotal);
		txtFNavTotal.setColumns(10);

		JButton btnFNavAdd = new JButton("");
		btnFNavAdd
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-add-icon 2.png")));
		tlbrFileNav.add(btnFNavAdd);

		JButton btnFNavDel = new JButton("");
		btnFNavDel
				.setIcon(new ImageIcon(
						AccountViewJ.class
								.getResource("/com/swysoft/swybanking/pics/Actions-list-remove-icon 2.png")));
		tlbrFileNav.add(btnFNavDel);

		JButton btnFNavEscape = new JButton("Escape");
		btnFNavEscape.setFont(new Font("Tahoma", Font.PLAIN, 11));
		tlbrFileNav.add(btnFNavEscape);

	}

	protected void initDataBindings() {
		BeanProperty<CatLookUpMdl, List<String>> catLookUpMdlBeanProperty = BeanProperty
				.create("codeList");
		JComboBoxBinding<String, CatLookUpMdl, JComboBox> jComboBinding_1 = SwingBindings
				.createJComboBoxBinding(UpdateStrategy.READ, catLookUpMdl,
						catLookUpMdlBeanProperty, cboCategory);
		jComboBinding_1.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_3 = BeanProperty
				.create("category");
		BeanProperty<JComboBox, Object> jComboBoxBeanProperty = BeanProperty
				.create("selectedItem");
		AutoBinding<QifMdl, String, JComboBox, Object> autoBinding_12 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_3, cboCategory,
						jComboBoxBeanProperty);
		autoBinding_12.bind();
		//
		BeanProperty<AccountMdl, List<String>> accountMdlBeanProperty_9 = BeanProperty
				.create("codeList");
		JComboBoxBinding<String, AccountMdl, JComboBox> jComboBinding = SwingBindings
				.createJComboBoxBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_9, cboCode);
		jComboBinding.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_10 = BeanProperty
				.create("codeKey");
		BeanProperty<JComboBox, String> jComboBoxBeanProperty_1 = BeanProperty
				.create("selectedItem");
		AutoBinding<AccountMdl, String, JComboBox, String> autoBinding_18 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_10, cboCode,
						jComboBoxBeanProperty_1);
		autoBinding_18.bind();
		//
		BeanProperty<ComboLookUpMdl, List<String>> comboLookUpMdlBeanProperty = BeanProperty
				.create("resultSet");
		JComboBoxBinding<String, ComboLookUpMdl, JComboBox> jComboBinding_2 = SwingBindings
				.createJComboBoxBinding(UpdateStrategy.READ, cboPayeeLkUpMdl,
						comboLookUpMdlBeanProperty, cboPayee);
		jComboBinding_2.bind();
		//
		BeanProperty<AccountMdl, Boolean> accountMdlBeanProperty_1 = BeanProperty
				.create("currentAcc");
		BeanProperty<JCheckBox, Boolean> jCheckBoxBeanProperty = BeanProperty
				.create("selected");
		AutoBinding<AccountMdl, Boolean, JCheckBox, Boolean> autoBinding_1 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_1, cbxCurrent,
						jCheckBoxBeanProperty);
		autoBinding_1.bind();
		//
		BeanProperty<AccountMdl, Boolean> accountMdlBeanProperty_8 = BeanProperty
				.create("showCurrent");
		AutoBinding<AccountMdl, Boolean, JCheckBox, Boolean> autoBinding_8 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_8, cbxShowOnlyCurrent,
						jCheckBoxBeanProperty);
		autoBinding_8.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty = BeanProperty
				.create("code");
		BeanProperty<JTextField, String> jTextFieldBeanProperty = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty, txtCode, jTextFieldBeanProperty);
		autoBinding.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_2 = BeanProperty
				.create("description");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_1 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding_2 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_2, txtDescription,
						jTextFieldBeanProperty_1);
		autoBinding_2.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_3 = BeanProperty
				.create("impFile");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_2 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding_3 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_3, txtBankfile,
						jTextFieldBeanProperty_2);
		autoBinding_3.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_4 = BeanProperty
				.create("upldFile");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_3 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding_4 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_4, txtCnvtToFile,
						jTextFieldBeanProperty_3);
		autoBinding_4.bind();
		//
		BeanProperty<AccountMdl, Integer> accountMdlBeanProperty_5 = BeanProperty
				.create("id");
		BeanProperty<JLabel, String> jLabelBeanProperty = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, Integer, JLabel, String> autoBinding_5 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_5, lblIdVal, jLabelBeanProperty);
		autoBinding_5.bind();
		//
		BeanProperty<AccountMdl, Integer> accountMdlBeanProperty_6 = BeanProperty
				.create("rowNum");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_4 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, Integer, JTextField, String> autoBinding_6 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, accountMdl,
						accountMdlBeanProperty_6, txtFNavRowNum,
						jTextFieldBeanProperty_4);
		autoBinding_6.bind();
		//
		BeanProperty<AccountMdl, Integer> accountMdlBeanProperty_7 = BeanProperty
				.create("rowTot");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_5 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, Integer, JTextField, String> autoBinding_7 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_7, txtFNavTotal,
						jTextFieldBeanProperty_5);
		autoBinding_7.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_1 = BeanProperty
				.create("inputFilePathStr");
		AutoBinding<AccountMdl, String, QifMdl, String> autoBinding_10 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_4, convtdQifMdl,
						qifMdlBeanProperty_1);
		autoBinding_10.bind();
		//
		AutoBinding<AccountMdl, String, QifMdl, String> autoBinding_20 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_3, bankQifMdl,
						qifMdlBeanProperty_1);
		autoBinding_20.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty = BeanProperty
				.create("tranDate");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_6 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, String, JTextField, String> autoBinding_9 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty, txtDate, jTextFieldBeanProperty_6);
		autoBinding_9.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_2 = BeanProperty
				.create("amountStr");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_7 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, String, JTextField, String> autoBinding_11 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_2, txtAmount,
						jTextFieldBeanProperty_7);
		autoBinding_11.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_4 = BeanProperty
				.create("chequeNumber");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_8 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, String, JTextField, String> autoBinding_13 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_4, txtChequeNum,
						jTextFieldBeanProperty_8);
		autoBinding_13.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_5 = BeanProperty
				.create("payee");
		AutoBinding<QifMdl, String, JComboBox, Object> autoBinding_14 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_5, cboPayee, jComboBoxBeanProperty);
		autoBinding_14.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_6 = BeanProperty
				.create("memo");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_9 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, String, JTextField, String> autoBinding_15 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_6, txtMemo, jTextFieldBeanProperty_9);
		autoBinding_15.bind();
		//
		BeanProperty<QifMdl, Integer> qifMdlBeanProperty_7 = BeanProperty
				.create("rowNum");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_10 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, Integer, JTextField, String> autoBinding_16 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_7, txtQNavRowNum,
						jTextFieldBeanProperty_10);
		autoBinding_16.bind();
		//
		BeanProperty<QifMdl, Integer> qifMdlBeanProperty_8 = BeanProperty
				.create("rowTot");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_11 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, Integer, JTextField, String> autoBinding_17 = Bindings
				.createAutoBinding(UpdateStrategy.READ, convtdQifMdl,
						qifMdlBeanProperty_8, txtQNavTotal,
						jTextFieldBeanProperty_11);
		autoBinding_17.bind();
		//
		BeanProperty<QifMdl, List<QifSplitFmt>> qifMdlBeanProperty_10 = BeanProperty
				.create("splits");
		BeanProperty<AccTblSplitsMdl, List> accTblSplitsMdlBeanProperty = BeanProperty
				.create("qifSplits");
		AutoBinding<QifMdl, List<QifSplitFmt>, AccTblSplitsMdl, List> autoBinding_19 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_10, accTblSplitsMdl,
						accTblSplitsMdlBeanProperty);
		autoBinding_19.bind();
		//
		BeanProperty<QifMdl, List<QifFmt>> qifMdlBeanProperty_9 = BeanProperty
				.create("qifTrans");
		BeanProperty<AccTblBankMdl, List<QifFmt>> qifRecdTblMdlBeanProperty = BeanProperty
				.create("qifTrans");
		AutoBinding<QifMdl, List<QifFmt>, AccTblBankMdl, List<QifFmt>> autoBinding_21 = Bindings
				.createAutoBinding(UpdateStrategy.READ, bankQifMdl,
						qifMdlBeanProperty_9, accTblBankMdl,
						qifRecdTblMdlBeanProperty);
		autoBinding_21.bind();
		//
		BeanProperty<AccountMdl, Color> accountMdlBeanProperty_11 = BeanProperty
				.create("impFileBkgrd");
		BeanProperty<JTextField, Color> jTextFieldBeanProperty_12 = BeanProperty
				.create("background");
		AutoBinding<AccountMdl, Color, JTextField, Color> autoBinding_22 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_11, txtBankfile,
						jTextFieldBeanProperty_12);
		autoBinding_22.bind();
		//
		BeanProperty<AccountMdl, Color> accountMdlBeanProperty_12 = BeanProperty
				.create("upldFileBkgrd");
		AutoBinding<AccountMdl, Color, JTextField, Color> autoBinding_23 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_12, txtCnvtToFile,
						jTextFieldBeanProperty_12);
		autoBinding_23.bind();
		//
		BeanProperty<QifMdl, Integer> qifMdlBeanProperty_11 = BeanProperty
				.create("accountRowNum");
		AutoBinding<AccountMdl, Integer, QifMdl, Integer> autoBinding_24 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_6, convtdQifMdl,
						qifMdlBeanProperty_11);
		autoBinding_24.bind();
		//
		BeanProperty<QifMdl, Boolean> qifMdlBeanProperty_13 = BeanProperty
				.create("splitsDiffShow");
		BeanProperty<JTextField, Boolean> jTextFieldBeanProperty_14 = BeanProperty
				.create("visible");
		AutoBinding<QifMdl, Boolean, JTextField, Boolean> autoBinding_26 = Bindings
				.createAutoBinding(UpdateStrategy.READ, convtdQifMdl,
						qifMdlBeanProperty_13, txtDifference,
						jTextFieldBeanProperty_14);
		autoBinding_26.bind();
		//
		BeanProperty<QifMdl, String> qifMdlBeanProperty_12 = BeanProperty
				.create("splitsDiffStr");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_13 = BeanProperty
				.create("text");
		AutoBinding<QifMdl, String, JTextField, String> autoBinding_25 = Bindings
				.createAutoBinding(UpdateStrategy.READ, convtdQifMdl,
						qifMdlBeanProperty_12, txtDifference,
						jTextFieldBeanProperty_13);
		autoBinding_25.bind();
		//
		BeanProperty<AccountMdl, Boolean> accountMdlBeanProperty_13 = BeanProperty
				.create("cvtdFlWrngShow");
		AutoBinding<AccountMdl, Boolean, JTextField, Boolean> autoBinding_27 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_13, txtConvrtFileWarning,
						jTextFieldBeanProperty_14);
		autoBinding_27.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_14 = BeanProperty
				.create("errMsg");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_15 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding_28 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_14, txtErrMsg,
						jTextFieldBeanProperty_15);
		autoBinding_28.bind();
		//
		BeanProperty<AccountMdl, Boolean> accountMdlBeanProperty_15 = BeanProperty
				.create("errShow");
		AutoBinding<AccountMdl, Boolean, JTextField, Boolean> autoBinding_29 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_15, txtErrMsg,
						jTextFieldBeanProperty_14);
		autoBinding_29.bind();
		//
		BeanProperty<AccountMdl, String> accountMdlBeanProperty_16 = BeanProperty
				.create("cvtdFlWrng");
		BeanProperty<JTextField, String> jTextFieldBeanProperty_16 = BeanProperty
				.create("text");
		AutoBinding<AccountMdl, String, JTextField, String> autoBinding_30 = Bindings
				.createAutoBinding(UpdateStrategy.READ, accountMdl,
						accountMdlBeanProperty_16, txtConvrtFileWarning,
						jTextFieldBeanProperty_16);
		autoBinding_30.bind();
		//
		BeanProperty<QifMdl, Boolean> qifMdlBeanProperty_14 = BeanProperty
				.create("clearedStatus");
		AutoBinding<QifMdl, Boolean, JCheckBox, Boolean> autoBinding_31 = Bindings
				.createAutoBinding(UpdateStrategy.READ_WRITE, convtdQifMdl,
						qifMdlBeanProperty_14, chckbxReconciled,
						jCheckBoxBeanProperty);
		autoBinding_31.bind();
		//
		BeanProperty<QifMdl, Boolean> qifMdlBeanProperty_15 = BeanProperty
				.create("failedConvsnShow");
		AutoBinding<QifMdl, Boolean, JTextField, Boolean> autoBinding_32 = Bindings
				.createAutoBinding(UpdateStrategy.READ, convtdQifMdl,
						qifMdlBeanProperty_15, txtFailedConvsn,
						jTextFieldBeanProperty_14);
		autoBinding_32.bind();
	}
}
